using UnityEngine;
using System.Collections;

abstract public class Affector : MonoBehaviour {
	
	public int complexity = 4;
	protected Transform player;
	protected PlayerPower playerPower;
	
	virtual public void Start()
	{
		this.player = Camera.mainCamera.transform;
		this.playerPower = this.player.GetComponent<PlayerPower>();
	}
	
	virtual public void Update()
	{
		if (this.complexity != 1)
		{
			if (this.transform.position.x < -1050 || this.transform.position.x > 1050
				|| this.transform.position.z < -1050 || this.transform.position.z > 1050)
			{
				this.Affect(-4, new RaycastHit());
			}
			if (this.transform.position.y < -80)
			{
				this.Affect(-4, new RaycastHit());
			}
		}
	}
	
	
	// Update is called once per frame
	abstract public bool Affect(int power, RaycastHit hit);
}
