using UnityEngine;
using System.Collections;
 
public class FlyCamera : MonoBehaviour {
 
     
    float mainSpeed = 100.0f; 
    float camSens = 0.25f; //How sensitive it with mouse
    private Vector3 lastMouse = new Vector3(255, 255, 255); //kind of in the middle of the screen, rather than at the top (play)
    private float totalRun= 1.0f;
	
	public bool hasMoved = false;
	public bool hasLooked = false;
	
	public bool canMove = true;
     
    void Update () {
        lastMouse = Input.mousePosition - lastMouse;
        lastMouse = new Vector3(-lastMouse.y * camSens, lastMouse.x * camSens, 0 );
        lastMouse = new Vector3(transform.eulerAngles.x + lastMouse.x , transform.eulerAngles.y + lastMouse.y, 0);
		if (Input.GetMouseButton(1) || Input.GetKey (KeyCode.LeftShift))
		{
			if (Input.GetKey (KeyCode.LeftShift))
				this.hasLooked = true;
        	transform.eulerAngles = lastMouse;
		}
        lastMouse =  Input.mousePosition;
        //Mouse & camera angle done.  
       
        //Keyboard commands
        Vector3 p = GetBaseInput();
        totalRun = Mathf.Clamp(totalRun * 0.5f, 1f, 1000f);
        p = p * mainSpeed;
        
		if (p != Vector3.zero && this.canMove)
		{
			this.rigidbody.drag = 0f;
	        p = p * Time.deltaTime;
			
			this.hasMoved = true;
		
			p = transform.TransformDirection(p);
			
			if (this.rigidbody.velocity.magnitude < 50)
			{
				this.rigidbody.AddForce(p*50);
			}
		}
		else
		{
			this.rigidbody.drag = 1f;
		}
		
		if (this.transform.position.x < -1005 || this.transform.position.x > 1005
			|| this.transform.position.z < -1005 || this.transform.position.z > 1005)
		{
			this.rigidbody.drag = 0;	
		}
		
		if (this.transform.position.x < -1050 || this.transform.position.x > 1050
			|| this.transform.position.z < -1050 || this.transform.position.z > 1050)
		{
			GameObject.Find("Monolith").GetComponentInChildren<TextMesh>().text = "That is suboptimal";
			GameObject.Find("Monolith").GetComponentInChildren<TextMesh>().fontSize = 800;
			this.canMove = false;
		}
		
		if (this.transform.position.y < -80)
		{
			GameObject.Find("Monolith").GetComponentInChildren<TextMesh>().text = "You potato...";
			GameObject.Find("Monolith").GetComponentInChildren<TextMesh>().fontSize = 800;
			this.canMove = false;
		}
    }
     
    private Vector3 GetBaseInput() { //returns the basic values, if it's 0 than it's not active.
        Vector3 p_Velocity = new Vector3();
        if (Input.GetKey (KeyCode.W)){
            p_Velocity += new Vector3(0, 0 , 1);
        }
        if (Input.GetKey (KeyCode.S)){
            p_Velocity += new Vector3(0, 0, -1);
        }
        if (Input.GetKey (KeyCode.A)){
            p_Velocity += new Vector3(-1, 0, 0);
        }
        if (Input.GetKey (KeyCode.D)){
            p_Velocity += new Vector3(1, 0, 0);
        }
        return p_Velocity;
    }
	
	public void OnCollisionEnter(Collision c)
	{
		//var x = c.contacts[0].point;
		//transform.position = x;
	}
	
	public void OnGUI() {
		if (!this.hasMoved) {
			GUI.Label(new Rect(Screen.width/2-50, Screen.height - 100, 100, 30), "Move: AWSD");
		}
		else if (!this.hasLooked) {
			GUI.Label(new Rect(Screen.width/2-150, Screen.height - 100, 300, 30), "Look: Hold Right Mouse Button OR Left Shift");
		}
	}
}