using UnityEngine;
using System.Collections;

public class MonolithBehavior : MonoBehaviour {
	
	Transform player;
	PlayerPower playerPower;
	
	// Use this for initialization
	void Start () {
		this.player = Camera.mainCamera.transform;
		this.playerPower = this.player.GetComponent<PlayerPower>();
		
		this.StartCoroutine(Progress());
	}
	
	public bool clicked = false;
	public bool nearCube = false;
	public bool nearObilisk = false;
	public bool minimizedCube = false;
	
	IEnumerator Progress()
	{
		if (this.playerPower.power == 0)
		{
			this.GetComponentInChildren<TextMesh>().text = "Come";
			this.nearObilisk = false;
			while (this.nearObilisk == false && this.playerPower.power == 0)
	        {
	            yield return null;
	        }		
		}
		this.GetComponent<AudioSource>().Play();
		if (this.playerPower.power == 0)
		{
			yield return new WaitForSeconds(.5f);
			this.GetComponentInChildren<TextMesh>().text = "Welcome";
			yield return new WaitForSeconds(4.5f);
			this.GetComponentInChildren<TextMesh>().text = "Reach out to me";
			this.clicked = false;
			while (this.clicked == false && this.playerPower.power == 0)
        	{
            	yield return null;
        	}
			this.GetComponentInChildren<TextMesh>().text = "Good";
			yield return new WaitForSeconds(2);
			this.GetComponentInChildren<TextMesh>().text = "I have given you power";
			this.player.GetComponent<PlayerPower>().power = -1;
			yield return new WaitForSeconds(4);
			this.GetComponentInChildren<TextMesh>().text = "Seek a Red Menace";
			
			this.nearCube = false;
			while (this.nearCube == false && this.playerPower.power == -1)
	        {
	            yield return null;
	        }
			this.GetComponentInChildren<TextMesh>().text = "Good";
			yield return new WaitForSeconds(2);
			this.GetComponentInChildren<TextMesh>().text = "Reach out to the Menace";
			this.minimizedCube = false;
			while (this.minimizedCube == false && this.playerPower.power == -1)
	        {
	            yield return null;
	        }
			this.GetComponentInChildren<TextMesh>().text = "Precisely";
			yield return new WaitForSeconds(2);
			this.GetComponentInChildren<TextMesh>().text = "The menace is minimized";
			yield return new WaitForSeconds(3);			
		}
		if (this.playerPower.power == -1)
		{
			this.GetComponentInChildren<TextMesh>().text = "Continue and experiment";
			while (this.playerPower.power == -1)
	        {
	            yield return null;
	        }
		}
		this.GetComponent<AudioSource>().Play();
		if (this.playerPower.power == -2)
		{
			this.GetComponentInChildren<TextMesh>().text = "Congratulations";
			yield return new WaitForSeconds(4);
			this.GetComponentInChildren<TextMesh>().text = "You can now do more";
			yield return new WaitForSeconds(4);
			this.GetComponentInChildren<TextMesh>().text = "The sky is the limit";
			
			while (this.playerPower.power == -2)
	        {
	            yield return null;
	        }
		}
		this.GetComponent<AudioSource>().Play();
		if (this.playerPower.power == -3)
		{
			this.GetComponentInChildren<TextMesh>().text = "The world resists.\n       Minimalize";
			//yield return new WaitForSeconds(5);
			//this.GetComponentInChildren<TextMesh>().text = "Minimalise";
			
			while (this.playerPower.power == -3)
	        {
	            yield return null;
	        }
		}
		this.GetComponent<AudioSource>().Play();
		if (this.playerPower.power == -4)
		{
			this.GetComponentInChildren<TextMesh>().text = "The final steps";
			yield return new WaitForSeconds(5);
			this.GetComponentInChildren<TextMesh>().text = "Think big";
			
			while (this.playerPower.power == -4 && this.playerPower.nukedTerrain == false)
	        {
	            yield return null;
	        }
		}
		
		this.GetComponent<AudioSource>().Play();
		this.GetComponentInChildren<TextMesh>().text = "It is done";
		yield return new WaitForSeconds(4);
		this.GetComponentInChildren<TextMesh>().text = "Don't you feel better now?";
		yield return new WaitForSeconds(4);
		
		foreach (var t in GameObject.Find("Affected").transform.GetComponentsInChildren<Affector>())
		{
			t.Affect(-4, new RaycastHit());
			t.Affect(-4, new RaycastHit());
			t.Affect(-4, new RaycastHit());
			yield return new WaitForSeconds(0.1f);
		}
		this.GetComponentInChildren<TextMesh>().text = " Minimized.\n  Simplified.\nIn " + (int)(Time.time/60) +" Minutes";
		
		GameObject.Find("WispText").renderer.enabled = true;
		
	}
	
	public void Update ()
	{
		if (!this.clicked && Input.GetMouseButtonDown(0)) {
			// Construct a ray from the current mouse coordinates
			var ray = Camera.mainCamera.ScreenPointToRay (Input.mousePosition);
			RaycastHit hit;
			if (Physics.Raycast (ray, out hit)) {
				if (hit.collider.gameObject == this.gameObject) {
					this.clicked = true;
				}				
			}
		}
		else if (this.clicked && !this.nearCube) {
			var hits = Physics.SphereCastAll(this.player.position, 50f, Vector3.forward, 1f, 1 << LayerMask.NameToLayer("Cubes"));
			foreach (var h in hits)
			{
				if (h.collider.GetComponent<CubeBehavior>())
				{
					this.nearCube = true;
					break;
				}
			}
		}
		
	}
		
}
