using UnityEngine;
using System.Collections;

public class PlayerPower : MonoBehaviour {
	
	public int power = 0;
	public int appliedThisLevel = 0;
	
	public int annihilatedThings = 0;
	
	public bool monolithRemoved = false;
	
	public bool nukedTerrain = false;
	
	Transform wisp;
	Transform monolith;
	
	// Use this for initialization
	void Start () {
		this.wisp = GameObject.Find("Wisp").transform;
		this.monolith = GameObject.Find("Monolith").transform;
	}
	
	// Update is called once per frame
	void Update () {
		if (this.power != 0 && Input.GetMouseButton(0))
		{
			var ray = Camera.mainCamera.ScreenPointToRay(Input.mousePosition);
			RaycastHit hit;
			if (Physics.Raycast (ray, out hit)) {
				var aff = hit.collider.GetComponent<Affector>();
				if (aff) 
				{
					if (aff.Affect(this.power, hit))
					{
						this.appliedThisLevel++;
						
						if (this.power == -1 && this.appliedThisLevel >= 5)
						{
							this.power = -2;
							this.appliedThisLevel = 0;
						}
						else if (this.power == -2 && this.appliedThisLevel >= 15)
						{
							this.power = -3;
							this.appliedThisLevel = 0;
						}
						else if (this.power == -3 && this.appliedThisLevel >= 10) // Terrain no longer viable
						{
							this.power = -4;
							this.appliedThisLevel = 0;
						}
						else if (this.power == -4 && this.annihilatedThings == 10)
						{
							this.power = -5;
						}
						else if (this.power == 1 && this.appliedThisLevel >= 5)
						{
							this.power = 2;
						}
						else if (this.power == 2 && this.appliedThisLevel >= 20)
						{
							this.power = 3;
						}
						else if (this.power == 3 && this.appliedThisLevel >= 30)
						{
							this.power = 4;
						}
						else if (this.power == 4 && this.monolithRemoved)
						{
							this.power = 5;
						}
					}
				}				
			}
		}
	}
}
